<?php
// $Id: banking.admin.inc,v 1.1 2009/06/20 04:21:36 arto Exp $

//////////////////////////////////////////////////////////////////////////////
// Settings form

function banking_admin_settings() {
  $form = array();

  $form['countries'] = array(
    '#type'          => 'fieldset',
    '#title'         => t('Countries'),
    '#collapsible'   => TRUE,
    '#collapsed'     => FALSE,
    '#description'   => t('Select which countries to enable banking functionality for.'),
  );
  $form['countries']['banking_countries'] = array(
    '#type'          => 'checkboxes',
    '#title'         => NULL,
    '#options'       => array_combine(array_keys($title = banking_get_countries('title')), array_fill(0, count($title), '')),
    '#default_value' => array_keys(banking_get_countries(NULL, TRUE)),
    '#description'   => NULL,
  );

  return array_merge_recursive(system_settings_form($form), array('#theme' => 'banking_admin_settings', 'buttons' => array('#weight' => 99)));
}

function banking_admin_settings_validate($form, &$form_state) {
  extract($form_state['values'], EXTR_SKIP | EXTR_REFS);

  // Filter out disabled countries:
  $banking_countries = array_filter($banking_countries, 'is_string');
}

function theme_banking_admin_settings($form) {
  $head = array(t('Enabled'), t('Code'), array('data' => t('Name'), 'width' => '80%'), array('data' => t('Account Types'), 'width' => '20%', 'nowrap' => 'nowrap'));

  $rows = array();
  foreach (banking_get_countries() as $country_code => $country) {
    $account_type = isset($country->iban) ? t('IBAN (!length digits)', array('!length' => (int)$country->iban['length'])) : t('Other'); // FIXME

    $rows[] = array(
      array('data' => drupal_render($form['countries']['banking_countries'][$country_code]), 'align' => 'center'),
      check_plain($country_code),
      check_plain($country->title),
      str_replace(' ', '&nbsp;', $account_type),
    );
  }

  if (empty($rows)) {
    $rows[] = array(array('data' => t('No banking countries available.'), 'colspan' => '4'));
  }

  $form['countries']['#value'] = theme('table', $head, $rows, array('class' => 'banking countries'));
  return drupal_render($form);
}
